clear all
close all


%% LP Filter
filtername = 'LP';
load('LP.mat');
h = Num;
N = length(h)-1;

fs = 48e3;
fpass = 10e3;
fstop = 11e3;

%% Plot Frequency response with threshold
%plot one frequency response
wp_range = [0, fpass/(fs/2)]*pi;
wp_threshold = [1];
ws_range = [fstop/(fs/2), 1]*pi;
ws_threshold = -20;
plot_frequency(h, wp_range, wp_threshold, ws_range, ws_threshold);


%%

load('sparse_LP_-20dB_result.mat');
figure
plot(delta_si, 'b')
hold on
plot(delta_sc, 'r')
% plot(delta_sm1(3:length(delta_sm1),3),delta_sm1(3:length(delta_sm1),2), 'g')
plot(delta_sm1, 'g')

xlabel('iterations')
ylabel('delta')
legend('smallest increase', 'smallest coefficient', 'smallest minimum 1 norm');
%%
% break

index = -40:5:-20;
for it = 1:length(index)
    load(strcat('sparse_LP_', num2str(index(it)), 'dB_result.mat'));
    zer(1,it) = length(Z_si);
    zer(2,it) = length(Z_sc);
    zer(3,it) = length(Z_sm1);
end
figure
plot(index, zer(1,:), 'b')
hold on
plot(index, zer(2,:), 'r')
plot(index, zer(3,:), 'g')

xlabel('threshold in dB')
ylabel('number of zeros')
legend('smallest increase', 'smallest coefficient', 'smallest minimum 1 norm');

%% Plot Increase of error per zeroes

load('sparse_LP_-20dB_result.mat');
figure
plot(error_dB_si)
hold on
plot(error_dB_sco, 'r')
xlabel('number of zero-elements')
ylabel('maximal Error in Stopband / dB')
title('Increase of Error by adding zero-elements')
legend('minimum increase', 'smallest coefficient')


%% Plot b_n
load('sparse_LP_-20dB_result.mat');


figure
subplot(4,1,1)
[b, M] =getb(h);
N = setdiff(1:M,[]);
stem(N-1, b(N));
max_N = length(N);
axis([0 max_N -1 1]);
xlabel('original filter');
ylabel('b_n');

subplot(4,1,2)
[b, M] =getb(h_si);
N = setdiff(1:M,Z_si);
stem(N-1, b(N));
axis([0 max_N -1 1]);
xlabel('minimum increase');
ylabel('b_n');

subplot(4,1,3)
[b, M] =getb(h_sc);
N = setdiff(1:M,Z_sc);
stem(N-1, b(N));
axis([0 max_N -1 1]);
xlabel('smallest coefficient');
ylabel('b_n');

subplot(4,1,4)
[b, M] =getb(h_sm1);
N = setdiff(1:M,Z_sm1);
stem(N-1, b(N));
axis([0 max_N -1 1]);
xlabel('mimimum 1 norm');
ylabel('b_n');

%% table
index = -40:5:-20;
for it = 1:length(index)
    load(strcat('sparse_LP_', num2str(index(it)), 'dB_result.mat'));
    nzer(1,it) = 51-length(Z_si);
    nzer(2,it) = 51-length(Z_sc);
    nzer(3,it) = 51-length(Z_sm1);
end

nzer

%% h -> b

figure
stem(h)
axis([0 101 -0.2 0.7])
figure
stem(getb(h))
axis([0 51 -0.2 0.7])



%% FIN

