function [ b, varargout ] = getb( h )
%[ b, M ] = getb( h )
%
% return the parameterized coefficient vector of h
%
%   input:
%       h               coefficient vector
%
%   output:
%       b               parameterized coefficent vector
%       M   (optional)  length of b
%
%   Author      Peter Reinprecht
%   Date        Januar 2012
%   Subject     Advanced Signalprocessing 1, Seminar - WS 2011/12
%

N = length(h)-1;
M = N/2;

b = zeros(M+1,1);
b(1) = h(M+1);
b(2:M+1) = 2*h(M+2:N+1);

%return optional output
varargout = {M};

end

