function [ h, varargout ] = geth( b )
%[ h, N ] = geth( b )
%
% return the impulse response from the parameterized coefficient vector
%
%   input:
%       b               parameterized coefficent vector
%
%   output:
%       h               coefficient vector
%       N   (optional)  length of h
%
%   Author      Peter Reinprecht
%   Date        Januar 2012
%   Subject     Advanced Signalprocessing 1, Seminar - WS 2011/12
%


N = 2*length(b)-2;

h = zeros(1,N+1);
h(1:N/2) = b(N/2+1:-1:2)/2;
h(N/2+1) = b(1);
h(N/2+2:N+1) = b(2:N/2+1)/2;

%return optional output
varargout = {N};

end

