function [ output_args ] = plot_frequency( h, wpr, wpt, wsr, wst )
%PLOT_FREQUENCY Summary of this function goes here
%   Detailed explanation goes here

[b, M] = getb(h);

[hval, hfreq] = freqz(h);
resp = 20*log10(abs(hval));

%% define frequency bounds
bound = ones(length(hval),1)*[10, -inf];  %[upper bound, lower bound] LINEAR!!!
% bound = ones(length(hval),1)*[inf, -inf];  %[upper bound, lower bound] LINEAR!!!

%stopband;
N_ws = length(wst);
for k = 1:N_ws
    range = find(hfreq > wsr(k,1) & hfreq < wsr(k,2));
    bound(range, 1) = wst(k);
end
stoprange = range;

%passband
N_wp = length(wpt);
wpassoffset = 0;
for k = 1:N_wp
    range = find(hfreq > wpr(k,1) & hfreq < wpr(k,2));
    bound(range, 1) = wpassoffset + wpt(k);   %upper bound
    bound(range, 2) = wpassoffset - wpt(k);   %lower bound
end


%% plot frequency response
f_range = linspace(0, 48e3/2, length(hval));
max_y = 10;
min_y = -70;
maxline = max_y * ones(1,length(hval));
minline = min_y * ones(1,length(hval));

plot(f_range, 20*log10(abs(hval)))
axis([0 24000 min_y max_y])
hold on

plot(f_range, maxline, 'r'); 
hold on
plot(f_range, bound(:,1), 'r'); 
hold on
boundplot = bound(:,1)';
boundplot(boundplot > max_y) = max_y;
h1 = fill([f_range flipdim(f_range,2)], [boundplot flipdim(maxline,2)],'k','Edgecolor', 'none'); 
set(h1,'FaceAlpha',[0.3]) 

plot(f_range, minline, 'r'); 
hold on
plot(f_range, bound(:,2), 'r'); 
hold on
boundplot = bound(:,2)';
boundplot(boundplot < min_y) = min_y;
h2 = fill([f_range flipdim(f_range,2)], [boundplot flipdim(minline,2)],'k','Edgecolor', 'none'); 
set(h2,'FaceAlpha',[0.3]) 

title('Definition of Threshold Levels')
xlabel('Frequency / kHz')
ylabel('Attenuation / dB')
end

